"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/*
 * Copyright 2016 Simon Edwards <simon@simonzone.com>
 *
 * This source code is licensed under the MIT license which is detailed in the LICENSE.txt file.
 */
const CodeMirror = require("codemirror");
/* This little module encapsulates a way of grouping many updates to
 * CodeMirror instances in one batch which efficiently updates the DOM.
 */
let codeMirrorInstance = null;
function bulkOperation(func) {
    if (codeMirrorInstance === null) {
        const holderDiv = window.document.createElement('div');
        holderDiv.style.width = "0px";
        holderDiv.style.height = "0px";
        holderDiv.style.top = "0px";
        holderDiv.style.bottom = "0px";
        holderDiv.style.position = "absolute";
        holderDiv.style.overflow = "hidden";
        document.body.appendChild(holderDiv);
        const options = {
            value: "",
            readOnly: true,
            scrollbarStyle: "null",
            cursorScrollMargin: 0,
            showCursorWhenSelecting: false,
            mode: null,
        };
        // Create the CodeMirror instance
        codeMirrorInstance = CodeMirror((el) => {
            holderDiv.appendChild(el);
        }, options);
    }
    codeMirrorInstance.operation(func);
}
exports.bulkOperation = bulkOperation;
//# sourceMappingURL=CodeMirrorOperation.js.map