"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SESSION_TYPE_UNIX = "unix";
exports.SESSION_TYPE_CYGWIN = "cygwin";
exports.SESSION_TYPE_BABUN = "babun";
function envContext(systemConfig) {
    const context = new Map();
    context.set("HOME_DIR", systemConfig.homeDir);
    return context;
}
exports.envContext = envContext;
function expandEnvVariables(extraEnv, context) {
    const expandedEnv = {};
    if (extraEnv !== null && extraEnv !== undefined) {
        let prop;
        for (prop in extraEnv) {
            expandedEnv[prop] = expandEnvVariable(extraEnv[prop], context);
        }
    }
    return expandedEnv;
}
exports.expandEnvVariables = expandEnvVariables;
function expandEnvVariable(value, context) {
    let result = value;
    let prop;
    context.forEach((value, prop) => {
        const re = new RegExp("\\$\\{" + prop + "\\}", "g");
        result = result.replace(re, value);
    });
    return result;
}
exports.expandEnvVariable = expandEnvVariable;
function isAcceptsConfigManager(instance) {
    return instance.setConfigManager !== undefined;
}
exports.isAcceptsConfigManager = isAcceptsConfigManager;
function injectConfigManager(instance, configManager) {
    if (isAcceptsConfigManager(instance)) {
        instance.setConfigManager(configManager);
    }
}
exports.injectConfigManager = injectConfigManager;
//# sourceMappingURL=Config.js.map