"use strict";
/*
 * Copyright 2017 Simon Edwards <simon@simonzone.com>
 *
 * This source code is licensed under the MIT license which is detailed in the LICENSE.txt file.
 */
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const ExtensionLoader_1 = require("./ExtensionLoader");
function testHelloWorld(test) {
    const loader = new ExtensionLoader_1.ExtensionLoader([path.join(__dirname, "test/extensions")]);
    loader.scan();
    const extensions = loader.getExtensions();
    test.ok(extensions.length >= 1, "Found extensions");
    const helloWorldList = extensions.filter(extension => extension.name === "helloworld");
    test.equal(helloWorldList.length, 1);
    test.equal(helloWorldList[0].main, "main.js");
    test.equal(helloWorldList[0].version, "1.0.0");
    test.ok(loader.load(helloWorldList[0]), "Load module");
    const helloWorldModule = helloWorldList[0].module;
    const context = { activated: false };
    helloWorldModule.activate(context);
    test.equal(context.activated, true);
    test.done();
}
exports.testHelloWorld = testHelloWorld;
function testHelloDependency(test) {
    const loader = new ExtensionLoader_1.ExtensionLoader([path.join(__dirname, "test/extensions")]);
    loader.scan();
    const extensions = loader.getExtensions();
    test.ok(extensions.length >= 1, "Found extensions");
    const helloDependencyList = extensions.filter(extension => extension.name === "hellodependency");
    test.equal(helloDependencyList.length, 1);
    test.ok(loader.load(helloDependencyList[0]), "Load module");
    const helloDependencyModule = helloDependencyList[0].module;
    const context = { activated: false };
    helloDependencyModule.activate(context);
    test.equal(context.activated, true);
    test.done();
}
exports.testHelloDependency = testHelloDependency;
//# sourceMappingURL=ExtensionLoaderTest.js.map