"use strict";
/**
 * term.js - an xterm emulator
 * Copyright (c) 2012-2013, Christopher Jeffrey (MIT License)
 * Copyright (c) 2014-2017, Simon Edwards <simon@simonzone.com>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 * Originally forked from (with the author's permission):
 *   Fabrice Bellard's javascript vt100 for jslinux:
 *   http://bellard.org/jslinux/
 *   Copyright (c) 2011 Fabrice Bellard
 *   The original design remains. The terminal itself
 *   has been extended to include xterm CSI codes, among
 *   other features.
 *
 * Forked again from Christopher Jeffrey's work by Simon Edwards in 2014 and
 * converted over to TypeScript.
 */
Object.defineProperty(exports, "__esModule", { value: true });
function flagsFromCharAttr(attr) {
    return attr >> 18;
}
exports.flagsFromCharAttr = flagsFromCharAttr;
function foregroundFromCharAttr(attr) {
    return (attr >> 9) & 0x1ff;
}
exports.foregroundFromCharAttr = foregroundFromCharAttr;
function backgroundFromCharAttr(attr) {
    return attr & 0x1ff;
}
exports.backgroundFromCharAttr = backgroundFromCharAttr;
// Character rendering attributes packed inside a CharAttr.
exports.BOLD_ATTR_FLAG = 1;
exports.UNDERLINE_ATTR_FLAG = 2;
exports.BLINK_ATTR_FLAG = 4;
exports.INVERSE_ATTR_FLAG = 8;
exports.INVISIBLE_ATTR_FLAG = 16;
exports.ITALIC_ATTR_FLAG = 32;
exports.STRIKE_THROUGH_ATTR_FLAG = 64;
exports.FAINT_ATTR_FLAG = 128;
//# sourceMappingURL=TermApi.js.map